//---------------------------------------------------------------------------------
//                         Sofware I2c 
//				     Write By Mehdi rahimi @ 1391/2/31
//					 Email: mehdirhm222@gmail.com
//					 Publish In KavirElectronic.ir
//---------------------------------------------------------------------------------
#include <at91sam7x256.h>
#include <lib_at91sam7x256.h>
#include "I2C.h"
#include "tdelay.h"
#include "T138AF_reg.h"
typedef unsigned char uCHAR;
typedef unsigned int uINT;

#define SDA_OUT		AT91F_PIO_CfgOutput(I2C_PORT ,(1<<I2C_SDA))
#define SDA_IN		AT91F_PIO_CfgInput(I2C_PORT ,(1<<I2C_SDA))
#define SCL_OUT		AT91F_PIO_CfgOutput(I2C_PORT ,(1<<I2C_SCL))
#define SCL_IN		AT91F_PIO_CfgInput(I2C_PORT ,(1<<I2C_SCL))

#define SDA_HI		AT91F_PIO_SetOutput(I2C_PORT,1<<I2C_SCL)
#define SDA_LO		AT91F_PIO_ClearOutput(I2C_PORT,1<<I2C_SDA)

#define SCL_HI		AT91F_PIO_SetOutput(I2C_PORT,1<<I2C_SCL)
#define SCL_LO		AT91F_PIO_ClearOutput(I2C_PORT,1<<I2C_SCL)

#define Set_SDA_LOW			SDA_OUT;SDA_LO
#define Set_SDA_HIGH		SDA_IN;SDA_HI
#define Set_SCL_LOW			SCL_LO	// Clock Low Output
#define Set_SCL_HIGH		SCL_HI	// Clock High Output

#define I2CSDELAY		delay_us((1000/I2C_CLK))

void I2C_init(void)
{
	AT91C_BASE_PMC->PMC_PCER = ( 1<<I2C_PMC_PORT );
	SCL_OUT;  									// SCL Leitung als Ausgang definieren
	Set_SCL_HIGH;								// Cockleitung auf H setzen
	Set_SDA_HIGH;								// Datenleitung auf H setzen
	StopCondition();
}

void I2C_clk_toggle(void)
{
	
	Set_SCL_HIGH;
		I2CSDELAY;
	Set_SCL_LOW;
 		I2CSDELAY;
}

   // SET STOP CONDITION IN TWI BUS

void StartCondition(void)
{
	

	Set_SDA_HIGH;			// SDA vorsichtshalber auf HIGH ziehen
	Set_SCL_HIGH;			// SCL auf High	
	I2CSDELAY;
	Set_SDA_LOW;			// SDA auf Low ziehen
		I2CSDELAY;
		I2CSDELAY;
	Set_SCL_LOW;			// SCL auf low
		I2CSDELAY;
}
   // SET START CONDITION IN TWI BUS

void StopCondition(void)		
{
	
			I2CSDELAY;
	Set_SDA_LOW;			// SDA vorsichtshalber auf LOW ziehen
			I2CSDELAY;
	Set_SCL_HIGH;			// SCL auf High setzen
			I2CSDELAY;
	Set_SDA_HIGH;			// SDA von L auf H ziehen
			I2CSDELAY;
}


//--------------------------------------------------
// Send_Byte
//    Send a byte to master with a acknowledge bit
//--------------------------------------------------

unsigned char Send_Byte(unsigned char cData)    //     unsigned char i2csw_write(unsigned char b)
{	
		// END OF WORK SCL =0 , SDA = 1
	char i=0;
	for(i=0;i<8;i++)
	{
		if (cData & 0x80)	
		{
			Set_SDA_HIGH;
		}
		else
		{
			Set_SDA_LOW;
		}
		
		cData=cData<<1;
		I2CSDELAY;
		I2C_clk_toggle();
	}
	// Auf ACK vom Slave Prfen   
	Set_SDA_HIGH;
	//i2c_master_clk_toggle();		                                                                                                                   
	Set_SCL_HIGH;
	I2CSDELAY;
	if((AT91F_PIO_GetInput(I2C_PORT)&(1<<I2C_SDA))==0)	
	{
	Set_SCL_LOW;
		return 1;
	}
	else
	{ 
	Set_SCL_LOW;
		return 1;
	}	
}

//--------------------------------------------------
// Read_Byte
//    Read a byte from master with a acknowledge bit
//--------------------------------------------------

unsigned char Read_Byte(unsigned char cData)     //       unsigned char i2csw_read(unsigned char a)
{	
	unsigned char i,c=0x00;
	
	Set_SDA_HIGH;      

	for(i=0;i<8;i++)		
	{
		c=c<<1;				
		Set_SCL_HIGH;
		I2CSDELAY;
		// Bitweise OR verknpfen mit dem Eingang, MSB zuerst
		
		if((AT91F_PIO_GetInput(I2C_PORT)&(1<<I2C_SDA))) c|=1;			
		
		Set_SCL_LOW;
 		I2CSDELAY;
	}
	// ACK oder NACK | ACK=0; NACK=1
	if(cData==ACK)	
	{Set_SDA_LOW;} 
	else 
	{Set_SDA_HIGH;}  
	
	Set_SCL_HIGH;
		I2CSDELAY;
	Set_SCL_LOW;
		I2CSDELAY;
	return c;
}


unsigned char I2CWriteByte(unsigned char Dev_Addr, unsigned char Reg_Addr, unsigned char Data)
{
  StartCondition();	   // start condition 
  Dev_Addr &= 0xFE;   // Force WRITE address
  Send_Byte(Dev_Addr);	   /* send device ID and write data */
  Send_Byte(Reg_Addr);
  Send_Byte(Data);
  StopCondition();
  StopCondition();
  return(1);
}


 unsigned char I2CReadByte(unsigned char Dev_Addr, unsigned char Reg_Addr)
{
    unsigned char Result = 0;


    /* write reg offset */
    StartCondition();
    Send_Byte(Dev_Addr);
	Send_Byte(Reg_Addr); // Write address
	/* read data */
    StartCondition();
    Send_Byte(Dev_Addr | 0x01); // Read address
	Result = Read_Byte(1);
	StopCondition();
    return Result;
}




unsigned char I2CWriteByte1(unsigned char cDevAddr, unsigned char cReg, unsigned char cData)
{
 Set_SCL_LOW;
 Set_SDA_LOW;
Send_Byte(cDevAddr);
Send_Byte(cReg);
Send_Byte(cData);
  Set_SCL_LOW;
 Set_SDA_LOW;
    return(1);
}

//--------------------------------------------------
// 041901, Added for TWD Burst Write
// 1. PT8655X_Wr_Burst_A    (Start + Slave_ID + Address)
// 2. PT8655X_Wr_Burst_D    (Data)
// 3. PT8655X_Wr_Burst_P    (stop)
//--------------------------------------------------
uCHAR twdWr_Burst_A(unsigned char cReg)
{
    StartCondition();
    Send_Byte(T138AF);
    Send_Byte(cReg);
    return(1);                
}


void twdWr_Burst_D(unsigned char cData)
{
    uCHAR ix;

    for(ix = 0; ix < 8; ix++)
    {
        Set_SCL_LOW;
        if(cData&0x80)	
	{	
	Set_SDA_HIGH; 
	}
		
		else 
		{
		Set_SDA_LOW;
		cData<<=1;
        Set_SCL_HIGH;
		}
    }
    Set_SCL_LOW;
    Set_SDA_HIGH;               /* release data line for acknowledge */
    Set_SCL_HIGH;               /* Send a clock for Acknowledge */
//    if(SDA_High) cAcknowledge = 1; /* No Acknowledge */
    Set_SCL_LOW;                   /* Finish Acknoledge */

//    return(cAcknowledge);

}


void twdWr_Burst_P(void)
{
    StopCondition();
}



void twdDelay(unsigned long wLoops)
{
	unsigned long wTemp;

    while (wLoops--) {
	    wTemp = 1000/6;	// one loop below takes about 11 us
        while (wTemp--);
    }
}


// OSD config register Write
void OSD1CfgWr(unsigned char index,unsigned char dat)
{
 I2CWriteByte(T138AF,OSD1_CFG_INDEX,index);
 I2CWriteByte(T138AF,OSD1_CFG_DATA,dat);
}

// OSD2 config register Write
void OSD2CfgWr(unsigned char index,unsigned char dat)
{
    I2CWriteByte(T138AF,OSD2_CFG_INDEX,index);
    I2CWriteByte(T138AF,OSD2_CFG_DATA,dat);
}
void OSD1SetRamAddr(unsigned int address)
{
    I2CWriteByte(T138AF,OSD2_RAM_Addr & 0xF,(unsigned int)(address & 0xff));
    I2CWriteByte(T138AF,OSD2_RAM_Addr & 0xF0,(unsigned int)(address>>8));

}
void OSD1SetRamData(unsigned int wdata)
{
    I2CWriteByte(T138AF,OSD2_RAM_Data & 0xFF,(unsigned int)(wdata & 0xff));        
    I2CWriteByte(T138AF,OSD2_RAM_Data & 0xFF00,(unsigned int)(wdata>>8));
    
}
void OSD2SetRamAddr(unsigned int address)
{
    I2CWriteByte(T138AF,OSD2_RAM_Addr & 0xF,(unsigned int)(address & 0xff));
    I2CWriteByte(T138AF,OSD2_RAM_Addr & 0xF0,(unsigned int)(address>>8));

}
void OSD2SetRamData(unsigned int wdata)
{
    I2CWriteByte(T138AF,OSD2_RAM_Data & 0xFF,(unsigned char)(wdata & 0xff));        
    I2CWriteByte(T138AF,OSD2_RAM_Data & 0xFF00,(unsigned char)(wdata>>8));
    
}


unsigned char TunerReadByte(unsigned char cDevAddr)  //uCHAR cReg)
{
	unsigned char cResult = 0;
    
#ifdef TWO_TW_BUS
  gbTwBusSel=0; 
#endif
   /* read data */
   StartCondition();
   if (Send_Byte(cDevAddr | 0x01)) // Read address
		return 0;
   cResult = Read_Byte(1);

   StopCondition();
   return cResult;
}
//--------------------------------------------------
// Write Byte to Device 
//--------------------------------------------------
#define PAL

#ifdef PAL
#define STEPCODE	0xC8	//Step:50KHz
#endif
#ifdef NTSC
#define STEPCODE	0xCE	//Step:62.5KHz
#endif

unsigned char TunerWriteByte1(unsigned char cDevAddr, unsigned char cDecH, unsigned char cDecL,unsigned char bData, unsigned char cData)
{
    cDevAddr &= 0xFE;   // Force WRITE address
    
    // start condition 
    StartCondition();

    // send device ID and write data 
   if(!Send_Byte(cDevAddr))
   {
		if(!Send_Byte(cDecH))
		{
			if(!Send_Byte(cDecL))
        	{
				if(!Send_Byte(bData))
				{
           		if(!Send_Byte(cData))
            		{
               		StopCondition();
                		return(0);      // success 
					}
            	}
        	}
		}
    }
    StopCondition();
    return(1);                  // fail 
}

unsigned char TunerWriteByte(unsigned char cDevAddr, unsigned char cDecH, unsigned char cDecL, unsigned char cData)
{
    cDevAddr &= 0xFE;   // Force WRITE address
    
    // start condition 
    StartCondition();

    // send device ID and write data 
   if(!Send_Byte(cDevAddr))
   {
		if(!Send_Byte(cDecH))
		{
			if(!Send_Byte(cDecL))
        	{
				if(!Send_Byte(STEPCODE))
				{
           		if(!Send_Byte(cData))
            		{
               		StopCondition();
                		return(0);      // success 
					}
            	}
        	}
		}
    }
    StopCondition();
    return(1);                  // fail 
} 


unsigned char write_eeprom(int page_address,int data)

{
char result;
StartCondition();
result =Send_Byte(EEPROM_ADDRESS); 	           // SEND EEPROM ADR For Write
result+=Send_Byte((page_address >> 8 ) & 0xff);  // Send HI Byte Of ADR
result+=Send_Byte(page_address & 0xff);	       // Send LO Byte Of ADR
result+=Send_Byte(data);	                       // Send DATA TO Write
StopCondition();
return 1;
}

unsigned char read_eeprom(int page_address)

{
int result;
int read_data;
StartCondition();									   // send start condition	on twi bus
result=Send_Byte(EEPROM_ADDRESS);				   // SEND EEPROM ADR For Write
result+=Send_Byte((page_address >> 8 ) & 0xff);  // SEND high EEPROM ADR For Write
result+=Send_Byte(page_address & 0xff);		   // SEND low EEPROM ADR For Write
StartCondition();									   // send start condition	on twi bus
result+=Send_Byte(EEPROM_ADDRESS | 0x01);
read_data = Read_Byte(NACK);
StopCondition();
return read_data;
}

















