//---------------------------------------------------------------------------------
//							   Sofware I2c 
//				   Write By Mehdi rahimi @ 1391/2/31
//					Email: mehdirhm222@gmail.com
//					 Publish In KavirElectronic.ir
//---------------------------------------------------------------------------------
#ifndef I2C_H
#define I2C_H

#define I2C_PORT		AT91C_BASE_PIOA	   // or 	AT91C_BASE_PIOB
#define I2C_SDA		    10	  	
#define I2C_SCL		    11
#define I2C_PMC_PORT	AT91C_ID_PIOA	 // or 	 AT91C_ID_PIOB

// MAx Clk IS 1000 Khz
#define I2C_CLK		100	 // in KHz
#define EEPROM_ADDRESS  0xA0	         // eeprom address

#define	ACK				1						// Ack empfangen
#define	NACK			0						// Ack nicht empfangen


#define	TWD_SPEED       0x08		//value: 1 (Fastest), 2 (slower), ... N (much slower)
#define	TWD_LONG_TIME	(TWD_SPEED*8)
#define	TWD_SHORT_TIME	(TWD_SPEED*1)

void I2C_init(void);
void I2C_clk_toggle(void);
void StartCondition(void);					              //	  void I2C_start(void);
void StopCondition(void);					              //	  void I2C_stop(void);
unsigned char Send_Byte(unsigned char cData);			  //	  unsigned char i2csw_write   (unsigned char b);
unsigned char Read_Byte(unsigned char cData);			  //	  unsigned char i2csw_read    (unsigned char a);
unsigned char twdWr_Burst_A(unsigned char cReg);
void twdWr_Burst_D(unsigned char cData);
void twdWr_Burst_P(void);
unsigned char I2CWriteByte  (unsigned char cDevAddr, unsigned char cReg, unsigned char cData);
unsigned char I2CReadByte   (unsigned char cDevAddr, unsigned char cReg);
void twdWriteTable(unsigned char cDevAddr, char *pString);
void OSD1CfgWr(unsigned char index,unsigned char dat);
void OSD2CfgWr(unsigned char index,unsigned char dat);
void OSD1SetRamAddr(unsigned int address);
void OSD1SetRamData(unsigned int wdata);
void OSD2SetRamAddr(unsigned int address);
void OSD2SetRamData(unsigned int wdata);
unsigned char write_eeprom(int address,int data);
unsigned char read_eeprom(int address);

//#ifdef TV// TV_AVAILABLE
//16Bits IIC
unsigned char TunerReadByte(unsigned char cDevAddr);  
unsigned char TunerWriteByte(unsigned char cDevAddr, unsigned char cDecH, unsigned char cDecL, unsigned char cData);
unsigned char TunerWriteByte1(unsigned char cDevAddr, unsigned char cDecH, unsigned char cDecL,unsigned char bData, unsigned char cData);
#endif
